// pktconf.h
//

#ifndef _PKTCONF_H_
#define _PKTCONF_H_

#include <stdbool.h>
#include <stdint.h>

//
// EXPORTED TYPE DEFINITIONS
//

struct pktconf_opt_ll_node {
    const char * key;
    const char * value;
    uint_fast32_t keylen;
    uint_fast32_t valuelen;
    uint_fast32_t lineno;
    struct pktconf_opt_ll_node * next;
};

struct pktconf_option_ll {
    struct pktconf_opt_ll_node * head;
    uint_fast32_t len;
};

struct pktconf_sep_str_entry {
    const char * entry;
    uint_fast32_t entrylen;
    struct pktconf_sep_str_entry * next;
};

struct pktconf_sep_str_ll {
    struct pktconf_sep_str_entry * head;
    uint_fast32_t len;
};

//
// EXPORTED FUNCTION DECLARATIONS
//

//
// LINKED LIST LOAD AND CLEANUP FUNCTIONS
//

extern int pktconf_load_option (
    const char * confpath,
    struct pktconf_option_ll ** ll);
extern void pktconf_cleanup_option_ll (
    struct pktconf_option_ll * ll);

//
// VALUE STRING UTILITIES
//

extern int pktconf_parse_sep_str (
    const char * s, uint_fast32_t len,
    char sep, uint_fast32_t max_cnt,
    struct pktconf_sep_str_ll ** ll);
extern void pktconf_cleanup_sep_str_ll (
    struct pktconf_sep_str_ll * ll);

#endif