// key_dummy.c
//

#include <pktlab.h>

#include "private.h"

//
// EXPORTED FUNCTION DEFINITIONS
//

struct pktlab_publickey * pktlab_create_publickey(void) {
    trace("%s()", __func__);
    debug("%s not supported (SSL not enabled)", __func__);
    return NULL;
}

int pktlab_load_publickey_pem (
    const char * pem, uint_fast32_t pemlen,
    struct pktlab_publickey * k)
{
    trace("%s(pemlen:%u)", __func__, (unsigned) pemlen);
    debug("%s not supported (SSL not enabled)", __func__);
    return -1;
}

int pktlab_load_publickey_der (
    const uint8_t * der, uint_fast32_t derlen,
    struct pktlab_publickey * k)
{
    trace("%s(derlen:%u)", __func__, (unsigned) derlen);
    debug("%s not supported (SSL not enabled)", __func__);
    return -1;
}

int pktlab_load_publickey_raw (
    const uint8_t * bytes, uint_fast32_t len,
    struct pktlab_publickey * k)
{
    trace("%s(len:%u)", __func__, (unsigned) len);
    debug("%s not supported (SSL not enabled)", __func__);
    return -1;
}

int pktlab_cleanup_publickey(struct pktlab_publickey * k) {
    trace("%s(...)", __func__);
    debug("%s not supported (SSL not enabled)", __func__);
    return -1;
}

int pktlab_get_publickey_bytes (
    const struct pktlab_publickey * k,
    void * buf, uint_fast32_t buflen)
{
    trace("%s(buflen:%u)", __func__, (unsigned) buflen);
    debug("%s not supported (SSL not enabled)", __func__);
    return -1;
}

struct pktlab_privatekey * pktlab_create_privatekey(void) {
    trace("%s()", __func__);
    debug("%s not supported (SSL not enabled)", __func__);
    return NULL;
}

int pktlab_load_privatekey_pem (
    const char * pem, uint_fast32_t pemlen,
    const char * passphrase, struct pktlab_privatekey * k)
{
    trace("%s(pemlen:%u,passphrase:%s)",
        __func__, (unsigned) pemlen,
        (passphrase == NULL) ? "NULL":"REDACTED");
    debug("%s not supported (SSL not enabled)", __func__);
    return -1;
}

int pktlab_load_privatekey_der (
    const uint8_t * der, uint_fast32_t derlen,
    const char * passphrase, struct pktlab_privatekey * k)
{
    trace("%s(derlen:%u,passphrase:%s)",
        __func__, (unsigned) derlen,
        (passphrase == NULL) ? "NULL":"REDACTED");
    debug("%s not supported (SSL not enabled)", __func__);
    return -1;
}

int pktlab_load_privatekey_raw (
    const uint8_t * bytes, uint_fast32_t len,
    struct pktlab_privatekey * k)
{
    trace("%s(len:%u)", __func__, (unsigned) len);
    debug("%s not supported (SSL not enabled)", __func__);
    return -1;
}

int pktlab_cleanup_privatekey(struct pktlab_privatekey * k)
{
    trace("%s(...)", __func__);
    debug("%s not supported (SSL not enabled)", __func__);
    return -1;
}

int pktlab_get_privatekey_bytes (
    const struct pktlab_privatekey * k,
    void * buf, uint_fast32_t buflen)
{
    trace("%s(buflen:%u)", __func__, (unsigned) buflen);
    debug("%s not supported (SSL not enabled)", __func__);
    return -1;
}

int pktlab_get_key_identifier (
    const struct pktlab_publickey * k,
    void * buf, uint_fast32_t buflen)
{
    trace("%s(buflen:%u)", __func__, (unsigned) buflen);
    debug("%s not supported (SSL not enabled)", __func__);
    return -1;
}

struct pktlab_publickey * pktlab_get_publickey_from_privatekey (
    const struct pktlab_privatekey * k)
{
    trace("%s(...)", __func__);
    debug("%s not supported (SSL not enabled)", __func__);
    return NULL;
}