// cert.h
//

#ifndef _CERT_H_
#define _CERT_H_

#include <stdint.h>

#include <pktlab.h>
#include <pktconf.h>

#include "util.h"

//
// EXPORTED FUNCTION DECLARATIONS
//

extern int ll_load_cert_chain (
    const struct pktconf_sep_str_ll * sep_list,
    struct pktlab_certificate *** certs,
    uint_fast32_t * certno);
extern void free_certs (
    struct pktlab_certificate ** certs,
    uint_fast32_t certno);
extern int reorder_certs (
    struct pktlab_privatekey * controller_key,
    struct pktlab_certificate ** certs,
    uint_fast32_t certno);

extern int load_cert (
    const char * path,
    struct pktlab_certificate ** cert);

#endif