// manager.h
//

#ifndef _MANAGER_H_
#define _MANAGER_H_

#include <stdbool.h>

#include <sys/select.h>

#include <pktlab.h>

//
// EXPORTED FUNCTION DECLARATIONS
//

extern int manager_init (
    const char * confpath,
    const char * addr,
    char * exp_prog_n_args[]);
extern int manager_load(void);
extern int manager_start(void);

extern int manager_prepare_select (
    fd_set * rset, fd_set * wset,
    pktlab_time_t * select_until);
extern int manager_process_select (
    const fd_set * rset, const fd_set * wset,
    pktlab_time_t now);

extern int manager_wrapup(void);
extern int manager_cleanup(void);

extern bool manager_is_done(void);

#endif