// net.h
//

#ifndef _NET_H_
#define _NET_H_

#include <netdb.h>
#include <stdbool.h>
#include <sys/socket.h>

//
// EXPORTED FUNCTION DECLARATIONS
//

extern int parse_host_port (
    const char * hostport,
    char ** host, char ** port);
extern int parse_n_getaddrinfo (
    const char * hostport, int for_bind,
    struct addrinfo ** ai);

extern int setup_nonblock_connect_socket (
    struct addrinfo * ai, int * sock, int * err);
extern int check_nonblock_connect_socket(int sock, int * err);

extern int create_connect_socket (
    struct addrinfo * ai, int * sock);
extern int create_welcome_socket (
    struct addrinfo * ai, int * sock);
extern int accept_new_socket (
    int welcome_sock, int * new_sock,
    struct sockaddr_storage * sa, int * err);
extern int get_stream_socketpair(int fds[2], int * err);
extern int set_keepalive(int sktfd);
extern int set_nonblock(int sktfd, bool set);

extern int print_info_addr (
    const char * prestr, struct sockaddr_storage * sa);

#endif