// config.h
//

#ifndef _CONFIG_H_
#define _CONFIG_H_

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

#include <pktconf.h>

//
// EXPORTED TYPE DEFINITIONS
//

enum config_st {
    CONFIG_NOT_INIT = 0,
    CONFIG_INIT     = 1,
    CONFIG_READY    = 2
};


struct config {
    enum config_st state;
    unsigned long long network_bufmax;
    const char * vmem_laddr_str_v4;
    const char * vmem_laddr_str_v6;
    const char * vmem_ldnsaddr_str_v4;
    const char * vmem_ldnsaddr_str_v6;
    const char * host_id;
    bool raw_sup;
    bool tcp_sup;
    bool udp_sup;

    const char * broker_addr;
    const char * endpoint_agent_cert_path;
    const struct pktconf_sep_str_ll * broker_chain_troot_path_ll;

    const struct pktconf_sep_str_ll * broker_channel_ll;
    bool auto_extract_channel;

    const struct pktconf_sep_str_ll * subpriv_chain_path_ll;
    const struct pktconf_sep_str_ll * controller_chain_path_ll;
    const struct pktconf_sep_str_ll * eop_pubk_path_ll;
    const char* endpoint_privk_path;

    bool no_sub_mode;
};

//
// EXPORTED GLOBAL VARIABLES
//

extern struct config _config;

//
// EXPORTED FUNCTION DECLARATIONS
//

extern int config_initialize(void);
extern int config_read(const char * path, uint_fast32_t* errlineno);
extern void config_cleanup(void);

extern bool is_config_presence_correct(int * err);

#endif
