// console.c
//

#include "console.h"
#include "util.h"

#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>

//
// EXPORTED FUNCTION DEFINITIONS
//
void pktlabme_print_(const char *filename, int lineno, const char *label,
                     const char *fmt, ...) {
    static char buf[256];
    va_list args;

    va_start(args, fmt);
    vsnprintf(buf, sizeof(buf), fmt, args);
    va_end(args);

    fprintf(stderr, "%s (%s:%d): %s\n", label, filename, lineno, buf);
}

char *str_from_pktconf_ll(const struct pktconf_sep_str_ll *ll, char sep) {
    static char buf[4096];
    struct pktconf_sep_str_entry *entry;
    int i, off, cpy;

    off = 0;

    entry = ll->head;
    for (i = 0; i < ll->len; ++i) {
        assert(entry);
        cpy = MIN(entry->entrylen, sizeof(buf) - 2 - off);
        memcpy(buf + off, entry->entry, cpy);
        off += cpy;
        buf[off] = sep;
        off += 1;
        entry = entry->next;
    }
    buf[off] = '\0';

    return buf;
}