// filter_dummy.c
// Dummy filter impl. for non-supporting OS
//

#include <stdbool.h>
#include <stdint.h>

#include "console.h"
#include "raw.h"

//
// EXPORTED FUNCTION DEFINITIONS
//

int load_bpf_filter (
    const void * filter, uint_fast32_t filterlen,
    bool is_ebpf)
{
    trace("%s(filterlen:%u,is_ebpf:%d)",
        __func__, (unsigned) filterlen, (int) is_ebpf);
    debug("%s not supported due to OS restriction", __func__);
    return -128;
}

int run_bpf_filters (
    struct raw_prog * filters,
    const void * data, uint_fast32_t datalen)
{
    trace("%s(filters:%p,datalen:%u)",
        __func__, filters, (unsigned) datalen);
    debug("%s not supported due to OS restriction", __func__);
    return -128;
}