// key.h
//

#ifndef _KEY_H_
#define _KEY_H_

#include <stdint.h>

#include <pktlab.h>
#include <pktconf.h>

#include "util.h"

//
// EXPORTED FUNCTION DECLARATIONS
//

extern int ll_load_pubkeys (
    const struct pktconf_sep_str_ll * sep_list,
    struct pktlab_publickey *** pubkeys,
    uint_fast32_t * pubkeyno);
extern void free_pubkeys (
    struct pktlab_publickey ** pubkeys,
    uint_fast32_t pubkeyno);

extern int load_pubkey (
    const char * path,
    struct pktlab_publickey ** pubkey);
extern int load_privkey (
    const char * path, const char * passphrase,
    struct pktlab_privatekey ** privkey);
extern int load_key_w_prompt (
    const char * path,
    struct pktlab_privatekey ** privkey);

extern int find_signing_key (
    struct pktlab_publickey ** keyls, uint_fast32_t keynum,
    struct pktlab_certificate * cert, uint_fast32_t * skindx);

#endif